const int button = 2;

const int IN1 = 5;
const int IN2 = 6;
const int IN3 = 9;
const int IN4 = 10;

const int LED = 3;

const int MID = 650;

//const int min_spd = 0;
//const int av_spd = 150;
//const int max_spd = 255;
//
//const int KP = 25;
//const float KI = 0.1;
//const float KD = 0.0;

int d[9], sensor[8];

void forward()
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);

  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
}

void left()
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);

  digitalWrite(IN3, LOW);
  digitalWrite(IN4, HIGH);
}

void right()
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);

  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
}

void forw_left()
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);

  digitalWrite(IN3, LOW);
  digitalWrite(IN4, LOW);
}

void forw_right()
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);

  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
}

void update_liner()
{
  sensor[0] = analogRead(A0);
  sensor[1] = analogRead(A1);
  sensor[2] = analogRead(A2);
  sensor[3] = analogRead(A3);
  sensor[4] = analogRead(A4);
  sensor[5] = analogRead(A5);
  sensor[6] = analogRead(A6);
  sensor[7] = analogRead(A7);
  for (int i = 0; i < 8; i++)
  {
    if (sensor[i] > MID) d[i + 1] = 1;
    else d[i + 1] = 0;
  }
}

void print_liner()
{
  for (int i = 1; i <= 8; i++)
  {
    Serial.print(String(d[i]) + "\t");
  }
  Serial.println();
}

void logic()
{
  if ((d[8] == 0) &&
      ((d[6] == 1) || (d[5] == 1) || (d[4] == 1) || (d[3] == 1))
      && (d[1] == 0)) forward();
  else if ((d[8] == 0) && (d[7] == 1)) forw_left();
  else if (d[8] == 1) left();
  else if ((d[1] == 0) && (d[2] == 1)) forw_right();
  else if  (d[1] == 1) right();
}

//int result()
//{
//  int OUT = (-4 * d[1]) + (-3 * d[2]) + (-2 * d[3]) + (-1 * d[4])
//            + (1 * d[5]) + (2 * d[6]) + (3 * d[7]) + (4 * d[8]);
//  return OUT;
//}
//
//void motors(int spd)
//{
//
//  int speed_1 = constrain(av_spd + spd, min_spd, max_spd);
//  int speed_2 = constrain(av_spd - spd, min_spd, max_spd);
//
//  analogWrite(IN1, speed_1);
//  digitalWrite(IN2, LOW);
//
//  analogWrite(IN3, speed_2);
//  digitalWrite(IN4, LOW);
//}
//
//void prop()
//{
//  int error = result();
//  Serial.println(error);
//  motors(KP * error);
//}

void setup() {
  Serial.begin(115200);
  pinMode(button, INPUT);

  while (digitalRead(button) == 1)
  {
    delay(1);
  }

  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);

  pinMode(LED, OUTPUT);
  digitalWrite(LED, HIGH);
}



void loop() {
  update_liner();
  //print_liner();
  //forward();
  //left();
  //right();
  logic();
  //prop();

}
